/*
 * config.h
 * Copyright (C) Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * wmlogut is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * simple-netaid is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the COPYING file. * 
 */
 

#ifndef __CONFIG_H__
#define __CONFIG_H__

#include <gtkmm.h>

class Config
{  
public:
	Config(int, char**);
	virtual ~Config();
	
	virtual void get_pid();
	virtual void get_current_path();
	virtual void set_bin_path();
	virtual void get_pixmaps();
	
	std::vector<std::string> argvs;
	
	std::string PID,
				CURRENT_PATH,							 
				FILE_DESCRIPTOR,
				CLIENT,
				LOGO,
				SHUTDOWN_ICON,
				CANCEL_ICON,
				REBOOT_ICON,
				LOGOUT_ICON;
};

#endif // __CONFIG_H__
