 /*
 * main.cpp
 * Copyright (C) Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * simple-netaid is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * simple-netaid is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the COPYING file. * 
 */


#include <gtkmm.h>
#include <vector>
#include <iostream>
#include <memory>

#include "gtk/window_main.h"
#include "gtk/pipe_file.h"
#include "gtk/config.h"

int main (int argc , char **argv)
{
	
	auto params = std::make_unique<Config>(argc, argv);	
	//std::unique_ptr<Config> params(new Config(argc, argv));
	//std::unique_ptr<Config> params = std::make_unique<Config>(argc, argv);
	
#if GTK_MAJOR_VERSION == 2
/*
	Gtk::Main kit(argc, argv);
	WindowMain *window_main=Gtk::manage(new WindowMain(*params));
	Gtk::Main::run(*window_main);
	printf("Bye...!!");	
	return EXIT_SUCCESS;
	* */
	
	 Gtk::Main kit(argc, argv);
	 WindowMain window(params.get());
	 Gtk::Main::run(window);
	
#elif GTK_MAJOR_VERSION == 3

	auto app = Gtk::Application::create(argc, argv);
	WindowMain *window_main=Gtk::manage(new WindowMain(*params));	
	return app->run(*window_main);
		
#endif

}
