 /*
 * suid.cpp
 * Copyright (C) Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
 * 
 * wmlogout is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * simple-netaid is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; witkkkhout even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * See the COPYING file. * 
 */

#include <gtkmm.h>
#include <iostream>
#include <vector>
#include <memory>
//#include <unistd.h>
//#include <sys/reboot.h>

#include "gtk/cli.h"
#include "gtk/pipe_file.h"

using namespace std;

string get_pid();

int main(int argc, char **argv)
{
	auto cli = std::make_unique<Cli>("/tmp/wmlogout_" + get_pid() + ".socket");
	
	switch(stoi(cli->messages[0])) {
		
		case 0: sync();
				setuid(0);
				system("/sbin/poweroff");
				break;
		
		case 1: break;
	
		case 2: sync();
				setuid(0);
				system("/sbin/reboot");
				break;
			
		case 3: system("openbox --exit");
				break;
			
		default:
				break;	
	}

	return 0;
}

string get_pid()
{
	char *token=nullptr;
	auto fp = make_unique<PipeFile>();	
	vector<string> output = fp->get_output("ps -A | grep wmlogout");
	
	if(output.size() == 1) {
		const char delim[2] = " ";
		token=strtok((char*)output[0].c_str(), delim);
	} else throw runtime_error("Unable to get the pid of wmlogout.\n");
	
	return(string(token));
}
